#include "main.h"

unsigned char MyInB;
void main(void)
{
    osccon=0x72;           //8 MHz

    clockt=1;
    datat=1;

    write_ee();
    delay_s(2);
    read_ee();
	while(1){

	}
	
}

void write_ee(void){
//////////////////////////
/// Send start command ///
//////////////////////////
    start_ee();
//////////////////////////
/// Send Address       ///
/// 1010 - 000         ///
//////////////////////////
    SendX(1);
    SendX(0);
    SendX(1);
    SendX(0); //default

    SendX(0);
    SendX(0);
    SendX(0); //my address
//////////////////////////
/// MODE: Write        ///
//////////////////////////
    SendX(0); //write

    ClockMe();  //ack
//////////////////////////
/// Word Address       ///
/// 00000001 (0x01)    ///
//////////////////////////
    SendX(0);  
    SendX(0);
    SendX(0);
    SendX(0);
    SendX(0);
    SendX(0);
    SendX(0);
    SendX(1);

    ClockMe();  //ack
//////////////////////////
/// Data               ///
/// 00000010 (0x02)    ///
//////////////////////////
    SendX(0);  
    SendX(0);
    SendX(0);
    SendX(0);
    SendX(0);
    SendX(0);
    SendX(1);
    SendX(0);  

    ClockMe();  //ack
//////////////////////////
/// Send stop command  ///
//////////////////////////
    stop_ee();

}

void read_ee(void){
//////////////////////////
/// Send start command ///
//////////////////////////
    start_ee();
//////////////////////////
/// Send Address       ///
/// 1010 - 000         ///
//////////////////////////
    SendX(1);
    SendX(0);
    SendX(1);
    SendX(0); //default

    SendX(0);
    SendX(0);
    SendX(0); //my address
//////////////////////////
/// MODE: Write        ///
//////////////////////////
    SendX(0); //write

    ClockMe();  //ack
//////////////////////////
/// Word Address       ///
/// 00000001 (0x01)    ///
//////////////////////////
    SendX(0);  
    SendX(0);
    SendX(0);
    SendX(0);
    SendX(0);
    SendX(0);
    SendX(0);
    SendX(1);

    ClockMe();  //ack
//////////////////////////
/// Send start command ///
//////////////////////////
    start_ee();
//////////////////////////
/// Send Address       ///
/// 1010 - 000         ///
//////////////////////////
    SendX(1);
    SendX(0);
    SendX(1);
    SendX(0); //default

    SendX(0);
    SendX(0);
    SendX(0); //my address
//////////////////////////
/// MODE: Read         ///
//////////////////////////
    SendX(1);   //read

    ClockMe();  //ack
//////////////////////////
/// Get Data           ///
//////////////////////////
    datat=1;    //set input

    MyInB.7=datap;
    ClockMe();  //next

    MyInB.6=datap;
    ClockMe();  //next

    MyInB.5=datap;
    ClockMe();  //next

    MyInB.4=datap;
    ClockMe();  //next

    MyInB.3=datap;
    ClockMe();  //next

    MyInB.2=datap;
    ClockMe();  //next

    MyInB.1=datap;
    ClockMe();  //next

    MyInB.0=datap;
    ClockMe();  //next

    datat=0;
//////////////////////////
/// Send stop command  ///
//////////////////////////
    stop_ee();

}

void start_ee(void){
//////////////////////////
/// Send start command ///
//////////////////////////
    data=1;
    clock=1;
    data=0;
    delay_us(5);
    clock=0;   
}

void ClockMe (void){
    clock=0;
    datat=1;
    clock=1;
    delay_us(5);
    clock=0;
    datat=0;
}

void SendX (bit OneZero){
    clock=0;
    data=OneZero;
    clock=1;
    delay_us(5);
    clock=0;
}

void stop_ee(void){
//////////////////////////
/// Send stop command ///
//////////////////////////
    data=0;
    clock=1;
    data=1;
    delay_us(5);
    clock=0;

}